// hlavickove subory *******************************************************
// systemove funkcie
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
// GL a GLU kniznica
#include <GL/gl.h>
#include <GL/glu.h>
// funkcie SDL kniznice
#include <SDL/SDL.h>

// .h subor
#include "mOGL.h"

// konstruktor *************************************************************
mOGL::mOGL()
{
 StartInfoPos=10.0f; // pozicia vypisu 1. textu pocas startu aplikacie
	
 t_a=0; t_b=0; // pomocne premenne
	
 normals_onoff=0;  // normaly sa nekreslia
 help_onoff=0;     // napoveda sa nevypisuje
 lighting_onoff=1; // osvetlenie vypnute
 fog_onoff=0;      // hmla vypnuta
 pause_motion=0;   // casovo zavisly pohyb je mozny
	
 rot_x=0.0f; rot_y=0.0f; pos_y=4.0f; add_y=0.0025f;

 // koeficienty rovnice orezavacej roviny
 plane_equ[0]=0.0f; plane_equ[1]=-1.0f; plane_equ[2]=0.0f; plane_equ[3]=0.0f;
}

// destruktor **************************************************************
mOGL::~mOGL()
{

}

// vypis info pocas startu aplikacie ***************************************
void mOGL::PrintStartInfo(char *infotext)
{
 ogl_Text.OpenDrawString();
 ogl_Text.SetTextColor(1.0f,1.0f,1.0f);
 sprintf(ogl_Text.mybuf,infotext);
 ogl_Text.DrawString(10.0f,StartInfoPos);
 ogl_Text.CloseDrawString();

 // vymena zobrazovacich zasobnikov, zobrazenie sceny
 SDL_GL_SwapBuffers();

 // dalsi text bude vypisany na novu poziciu
 StartInfoPos+=20.0f;

 // pauza aby bol text aspon chvilku viditelny
 SDL_Delay(300);
}

// inicializacia OpenGL - nastavenie parametrov pre tvorbu OpenGL sceny ****
bool mOGL::gl_initialize(void)
{
 // definicia premennych ***************************************************
 for (t_a=0;t_a<8;t_a++) { // nastavenie 8-mich vseobecnych materialov
  ogl_Material[t_a].amb[0]=1.0f; ogl_Material[t_a].amb[1]=1.0f;
  ogl_Material[t_a].amb[2]=1.0f; ogl_Material[t_a].amb[3]=1.0f;
  ogl_Material[t_a].dif[0]=0.6f; ogl_Material[t_a].dif[1]=0.6f;
  ogl_Material[t_a].dif[2]=0.6f; ogl_Material[t_a].dif[3]=1.0f;
  ogl_Material[t_a].spe[0]=1.0f; ogl_Material[t_a].spe[1]=1.0f;
  ogl_Material[t_a].spe[2]=1.0f; ogl_Material[t_a].spe[3]=1.0f;
  ogl_Material[t_a].amb_dif[0]=0.25f; ogl_Material[t_a].amb_dif[1]=0.25f;
  ogl_Material[t_a].amb_dif[2]=0.25f; ogl_Material[t_a].amb_dif[3]=1.0f;
  ogl_Material[t_a].emi[0]=0.0f; ogl_Material[t_a].emi[1]=0.0f;
  ogl_Material[t_a].emi[2]=0.0f; ogl_Material[t_a].emi[3]=1.0f;
  ogl_Material[t_a].shi=0.0f;
  ogl_Material[t_a].transp=0.0f;
  ogl_Material[t_a].sillum[0]=0.0f; ogl_Material[t_a].sillum[1]=0.0f;
  ogl_Material[t_a].sillum[2]=0.0f; ogl_Material[t_a].sillum[3]=1.0f;
 }

 for (t_a=0;t_a<8;t_a++) { // nastavenie 8-mich vseobecnych svetiel
  ogl_Light[t_a].amb[0]=0.25f; ogl_Light[t_a].amb[1]=0.25f;
  ogl_Light[t_a].amb[2]=0.25f; ogl_Light[t_a].amb[3]=1.0f;
  ogl_Light[t_a].dif[0]=0.5f; ogl_Light[t_a].dif[1]=0.5f;
  ogl_Light[t_a].dif[2]=0.5f; ogl_Light[t_a].dif[3]=1.0f;
  ogl_Light[t_a].spe[0]=0.75f; ogl_Light[t_a].spe[1]=0.75f;
  ogl_Light[t_a].spe[2]=0.75f; ogl_Light[t_a].spe[3]=1.0f;
  ogl_Light[t_a].pos[0]=0.0f; ogl_Light[t_a].pos[1]=0.2f;
  ogl_Light[t_a].pos[2]=0.0f; ogl_Light[t_a].pos[3]=1.0f;
  // pos[3]=1.0f - vsesmerove svetlo, 0.0f - smerove svetlo
  ogl_Light[t_a].spot[0]=0.0f;
  ogl_Light[t_a].spot[1]=0.0f;
  ogl_Light[t_a].spot[2]=-1.0f;
 }

 // STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ --

 // nastavenie OpenGL renderovacich parametrov *****************************
 glClearColor(197.0f/255.0f,78.0f/255.0f,11.0f/255.0f,1.0f); // zasobnik farieb bude vymazavany modrou farbou
 //glClearColor(0.0f,0.0f,0.0f,0.5f);    // zasobnik farieb bude vymazavany ciernou farbou
 glClearDepth(1.0f);                   // zasobnik hlbky bude vymazavany nastavenim na 1.0f
 //glClearStencil(0);                    // zasobnik stencil bude vymazavany nastavenim na 0

 // nastavenie parametrov 1. svetla
 glLightfv(GL_LIGHT0,GL_AMBIENT,ogl_Light[0].amb);
 glLightfv(GL_LIGHT0,GL_DIFFUSE,ogl_Light[0].dif);
 glLightfv(GL_LIGHT0,GL_SPECULAR,ogl_Light[0].spe);
 glLightfv(GL_LIGHT0,GL_POSITION,ogl_Light[0].pos);
 glEnable(GL_LIGHT0);
 if (lighting_onoff) glEnable(GL_LIGHTING);
 else glDisable(GL_LIGHTING);

 glDepthFunc(GL_LEQUAL);    // typ porovnavacej funkcie pre urcenie z-vzdialenosti
 glEnable(GL_DEPTH_TEST); // zapnutie testovania hlbky

 glDisable(GL_CULL_FACE); // nastavenie poradia, v ktorom budu definovane body objektu
 glFrontFace(GL_CCW);     // reprezentovat privratene resp. odvratene plochy,
 glCullFace(GL_BACK);     // CCW - proti smeru hod. ruciciek, CW - v smere hod. ruciciek
 glEnable(GL_CULL_FACE);  // odvratene plochy sa nebudu spracovavat

 // vseobecny material objektov
 glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,ogl_Material[0].amb_dif);

 // pre Gourandove svetelne vypocty bude pouzity material priradeny objektu,
 // ktory bude ale stale ovplyvneny farbou zadavanou prikazom glColor
 glEnable(GL_COLOR_MATERIAL);
 // farba bude mat vplyv iba na 'diffuse' komponent materialu
 glColorMaterial(GL_FRONT,GL_DIFFUSE);
 // svetlo sa pocita len pre privratene strany
 glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,0);
 // svetelne vypocty su lokalne
 glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER,GL_TRUE);
 // zapnutie gourand-jemneho tienovania
 glShadeModel(GL_SMOOTH);
 // osvetlenie textur alias modulate
 //glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
 // realnejsie perspektivne vypocty a korekcie
 glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);

 ogl_FogColor[0]=0.5f; ogl_FogColor[1]=0.6f;
 ogl_FogColor[2]=0.75f; ogl_FogColor[3]=1.0f;
 glFogi(GL_FOG_MODE,GL_EXP2);        // typ hmly
 glFogfv(GL_FOG_COLOR,ogl_FogColor); // farba hmly
 glFogf(GL_FOG_DENSITY,0.05f);       // hustota hmly
 glHint(GL_FOG_HINT,GL_DONT_CARE);   // dalsie nastavenia
 glFogf(GL_FOG_START,2000.0f);       // pociatok viditelnosti hmly
 glFogf(GL_FOG_END,4000.0f);         // vzdialenost max. hmly
 if (fog_onoff) glEnable(GL_FOG);    // povolenie hmly

 // zapnutie poli vrcholov, normal, koordinatov textur
 //glEnableClientState(GL_VERTEX_ARRAY);
 //glEnableClientState(GL_NORMAL_ARRAY);
 //glEnableClientState(GL_TEXTURE_COORD_ARRAY);

 // antialiasing ciar alias smoothline
 //glEnable(GL_LINE_SMOOTH);
 //glHint(GL_LINE_SMOOTH_HINT,GL_NICEST);

 // funkcia pre vypocet priesvitnosti
 //glBlendFunc(GL_ONE,GL_ONE);
 //glEnable(GL_BLEND); // zapnutie vypoctu priesvitnosti
 //glLineWidth(1.5f);

 // trojuholniky budu vyplnene
 glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

 // zapnutie texturovania
 glEnable(GL_TEXTURE_2D);

 // nastavenie modu generovania koordinatov S (gulove mapovanie)
 //glTexGeni(GL_S,GL_TEXTURE_GEN_MODE,GL_SPHERE_MAP);
 // nastavenie modu generovania koordinatov T (gulove mapovanie)
 //glTexGeni(GL_T,GL_TEXTURE_GEN_MODE,GL_SPHERE_MAP);

 // INICIALIZACIA SCENY INICIALIZACIA SCENY INICIALIZACIA SCENY ------------

 // vymazanie zasobnika farieb a hlbky
 glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

 // inicializacia vypisovania OpenGL textu
 if (ogl_Text.text_initialize()) {
  fprintf(stderr,"Chyba inicializacie fontu!\n"); return(1);
 }

 PrintStartInfo("Nastavenie OpenGL stavoveho stroja...");
 PrintStartInfo("OK");

 PrintStartInfo("Vytvorenie oblohy...");
 // priprava objektu oblohy
 if (ogl_Objects.obj_sky_init("sky")) {
  fprintf(stderr,"Chyba vytvorenia oblohy!\n"); return(1);
 }
 PrintStartInfo("OK");
 /*
 PrintStartInfo("Inicializacia OpenGL rozsireni...");
 if (ogl_Ext.Ext_init()) {
  fprintf(stderr,"Chyba inicilizacie OpenGL rozsireni!\n"); return(1);
 }
 PrintStartInfo("OK");
 */
 PrintStartInfo("Nacitanie textur...");
 strcpy(fname,"data/"); strcat(fname,"particle"); strcat(fname,".bmp");
 if (ogl_Texture.LoadTexture(0,fname,TEXTURE_TRILINEAR)) {
  fprintf(stderr,"Chyba nahratia textur!\n"); return(1);
 }
 strcpy(fname,"data/"); strcat(fname,"oak"); strcat(fname,".bmp");
 if (ogl_Texture.LoadTexture(1,fname,TEXTURE_TRILINEAR)) {
  fprintf(stderr,"Chyba nahratia textur!\n"); return(1);
 }
 strcpy(fname,"data/"); strcat(fname,"grass"); strcat(fname,".bmp");
 if (ogl_Texture.LoadTexture(2,fname,TEXTURE_TRILINEAR)) {
  fprintf(stderr,"Chyba nahratia textur!\n"); return(1);
 }
 PrintStartInfo("OK");

 PrintStartInfo("Inicializacia kvadratickych objektov...");
 if (ogl_Objects.obj_quadratic_init()) {
  fprintf(stderr,"Chyba inicializacie kvadratickych objektov!\n"); return(1);
 }
 PrintStartInfo("OK");

 PrintStartInfo("Inicializacia ohna...");
 if (ogl_Fire.create(60,0.0f,0.0f,0.0f,0.7f,1.3f,1.1f,ogl_Texture.texture_id[0])) {
  fprintf(stderr,"Chyba inicializacie ohna!\n"); return(1);
 }
 ogl_Fire.setcolor(0.9f,0.3f,0.05f,1.0f);
 PrintStartInfo("OK");
 
 PrintStartInfo("START");
 
 return(0);
}

// vykreslenie OpenGL sceny ************************************************
int mOGL::gl_draw(void)
{
 // vymazanie zasobnika farieb, hlbky a stencil
 glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);//|GL_STENCIL_BUFFER_BIT);

 // zresetovanie modelovej matice
 glLoadIdentity();

 // TRANSFORMACIA SCENY PODLA NASTAVENI AKTUALNEJ KAMERY!
 glMultMatrixf(m_Camera[0].matrix);

 glPushMatrix();
 // vykreslenie oblohy
 ogl_Objects.obj_sky_draw(m_Camera[0].GetCameraTime());
 glPopMatrix();

 // TRANSFORMACIA SCENY PODLA NASTAVENI AKTUALNEJ KAMERY!
 glTranslatef(m_Camera[0].posx,m_Camera[0].posy,m_Camera[0].posz);

 // transformacia polohy svetla podla polohy kamery
 //ogl_Light[0].pos[0]=-m_Camera[0].posx;
 //ogl_Light[0].pos[1]=-m_Camera[0].posy;
 //ogl_Light[0].pos[2]=-m_Camera[0].posz;
 // umiestenenie svetla na preddefinovanu poziciu
 glLightfv(GL_LIGHT0,GL_POSITION,ogl_Light[0].pos);

 // vykreslenie objektov sceny - svetlo (zobrazene kockou)
 //glPushMatrix();
 //glTranslatef(ogl_Light[0].pos[0],ogl_Light[0].pos[1],ogl_Light[0].pos[2]);
 //ogl_Objects.obj_cube0(0.1f);
 //glPopMatrix();

 // vykrelenie plochy (trava)
 glPushMatrix();
 glTranslatef(-5.0f,-1.0f,5.0f);
 glBindTexture(GL_TEXTURE_2D,ogl_Texture.texture_id[2]);
 ogl_Objects.obj_XZplane2(10.0f);
 glPopMatrix();
 
 // vykreslenie valcov (drevo)
 glPushMatrix();
 glTranslatef(0.0f,-0.8f,-2.0f);
 glBindTexture(GL_TEXTURE_2D,ogl_Texture.texture_id[1]);
 glTranslatef(0.4f,0.0f,0.6f); glRotatef(5.0f,0.0f,1.0f,0.0f);
 ogl_Objects.obj_quadratic(5,0.8f,1.0f);
 glTranslatef(-1.3f,0.0f,-0.3f); glRotatef(-14.0f,0.0f,1.0f,0.0f);
 ogl_Objects.obj_quadratic(5,0.5f,1.0f);
 glTranslatef(0.8f,0.0f,0.7f); glRotatef(43.0f,0.0f,1.0f,0.0f);
 ogl_Objects.obj_quadratic(5,0.4f,1.0f);
 glTranslatef(-0.3f,0.0f,-0.4f); glRotatef(-12.0f,0.0f,1.0f,0.0f);
 ogl_Objects.obj_quadratic(5,0.7f,1.0f);
 glPopMatrix();

 // vykreslenie ohna
 glPushMatrix();
 glTranslatef(0.0f,0.0f,-0.5f);
 ogl_Fire.render();
 glPopMatrix();

 if (help_onoff) {
  // vypis textu - help
  ogl_Text.OpenDrawString();
  ogl_Text.SetTextColor(1.0f,0.8f,0.0f);
  ogl_Text.SetFontSize(10);

  sprintf(ogl_Text.mybuf,"ESC        ukoncenie aplikacie");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-20.0f);
  sprintf(ogl_Text.mybuf,"MYS        rotacia v danom smere a strelba");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-60.0f);
  sprintf(ogl_Text.mybuf,"SIPKY      posun dopredu,dozadu,vlavo,vpravo");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-80.0f);
  sprintf(ogl_Text.mybuf,"A,Z        posun hore,dole");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-100.0f);
  sprintf(ogl_Text.mybuf,"J          skok");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-120.0f);
  sprintf(ogl_Text.mybuf,"SHIFT      zrychlenie posunu");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-140.0f);
  sprintf(ogl_Text.mybuf,"Q,W        rotacia okolo doprednej osi vlavo,vpravo");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-160.0f);
  sprintf(ogl_Text.mybuf,"R          reinicializacia pohladu kamery");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-180.0f);
  sprintf(ogl_Text.mybuf,"C          zapnutie/vypnutie detekcie kolizii");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-200.0f);
  sprintf(ogl_Text.mybuf,"M          vyplnene trojuholniky/iba hrany trojuholnikov");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-240.0f);
  sprintf(ogl_Text.mybuf,"L          zapnutie/vypnutie osvetlenia");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-260.0f);
  sprintf(ogl_Text.mybuf,"N          zapnutie/vypnutie zobrazenia normal");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-280.0f);
  sprintf(ogl_Text.mybuf,"G          zapnutie/vypnutie hmly");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-300.0f);
  sprintf(ogl_Text.mybuf,"F          zmena typu hmly");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-320.0f);
  sprintf(ogl_Text.mybuf,"T          zapnutie/vypnutie texturovania");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-340.0f);
  sprintf(ogl_Text.mybuf,"H          zapnutie/vypnutie zobrazenia helpu");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-360.0f);

  ogl_Text.CloseDrawString();
 }
 else {
  // vypis textu - poloha kamery
  ogl_Text.OpenDrawString();
  ogl_Text.SetTextColor(1.0f,0.8f,0.0f);
  ogl_Text.SetFontSize(10);

  sprintf(ogl_Text.mybuf,"x:%6.2f",-m_Camera[0].posx);
  ogl_Text.DrawString(10.0f,30.0f);
  sprintf(ogl_Text.mybuf,"y:%6.2f",-m_Camera[0].posy);
  ogl_Text.DrawString(10.0f,20.0f);
  sprintf(ogl_Text.mybuf,"z:%6.2f",-m_Camera[0].posz);
  ogl_Text.DrawString(10.0f,10.0f);

  // vypis textu - pocet obrazkov za sekundu
  sprintf(ogl_Text.mybuf,"%i fps",(GLuint) m_Camera[0].ogl_fps);
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-20.0f);

  ogl_Text.CloseDrawString();
 }

 return(0);
}

// casovo zavisla uprava objektov ******************************************
int mOGL::gl_iddle(void)
{
 // priebeh "zivota" ohna je zavisly na case
 if (!pause_motion) ogl_Fire.update(0.0f,8.0f,0.0f,m_Camera[0].GetCameraTime());
	
 return(0);
}

// zmena sposobu zobrazenia objektov ***************************************
void mOGL::change_PolygonMode(void)
{
 glGetIntegerv(GL_POLYGON_MODE,&ogl_State[0]);

 // INFO: vypis nacitaneho stavu
 //fprintf(stderr,"ogl_State=%d\n",ogl_State[0]);

 if (ogl_State[0]==GL_LINE) glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
 else glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

 SDL_Delay(200);
}

// zap/vyp osvetlenia ******************************************************
void mOGL::change_LightingOnOff(void)
{
 if (glIsEnabled(GL_LIGHTING)) glDisable(GL_LIGHTING);
 else glEnable(GL_LIGHTING);

 SDL_Delay(200);
}

// zap/vyp vykreslovania normal ********************************************
void mOGL::change_NormalsOnOff(void)
{
 if (normals_onoff==0) normals_onoff=1; else normals_onoff=0;

 SDL_Delay(200);
}

// zap/vyp hmly ************************************************************
void mOGL::change_FogOnOff(void)
{
 if (glIsEnabled(GL_FOG)) glDisable(GL_FOG);
 else glEnable(GL_FOG);

 SDL_Delay(200);
}

// zmena parametrov hmly ***************************************************
void mOGL::change_FogMode(void)
{
 glGetIntegerv(GL_FOG_MODE,&ogl_State[0]);

 // INFO: vypis nacitaneho stavu
 //fprintf(stderr,"ogl_State=%d\n",ogl_State[0]);

 if (ogl_State[0]==GL_EXP) glFogi(GL_FOG_MODE,GL_EXP2);
 else if (ogl_State[0]==GL_EXP2) glFogi(GL_FOG_MODE,GL_LINEAR);
      else glFogi(GL_FOG_MODE,GL_EXP);

 SDL_Delay(200);
}

// zap/vyp texturovania ****************************************************
void mOGL::change_TexOnOff(void)
{
 if (glIsEnabled(GL_TEXTURE_2D)) glDisable(GL_TEXTURE_2D);
 else glEnable(GL_TEXTURE_2D);

 SDL_Delay(200);
}

// zap/vyp vypisu helpu ****************************************************
void mOGL::change_HelpOnOff(void)
{
 if (help_onoff==0) help_onoff=1; else help_onoff=0;
 
 SDL_Delay(200);
}

// zap/vyp casovo zavisleho pohybu objektov ********************************
void mOGL::change_PauseMotion(void)
{
 if (pause_motion==0) pause_motion=1; else pause_motion=0;
 
 SDL_Delay(200);
}
