// hlavickove subory *******************************************************
// systemove funkcie
#include <stdlib.h>
#include <string.h>
#include <math.h>
// GL a GLU kniznica
#include <GL/gl.h>
//#include <GL/glu.h>
// funkcie SDL kniznice
#include <SDL/SDL.h>

// .h subor
#include "mObjects.h"

// konstruktor *************************************************************
mObjects::mObjects()
{
 t_a=0.0f; t_b=0.0f;
 y1=0.0f; y2=0.0f; y3=0.0f; y4=0.0f;
	
 Ssphere.v_array=NULL; // obloha - pologula zatial neexistuje
 Ssphere.t_array=NULL;
	
 PlaneVertices=NULL;   // oblaky - zakrivena plocha zatial neexistuje
 Indices=NULL;
}

// destruktor **************************************************************
mObjects::~mObjects()
{
 destroy_Ssphere(); // zrusenie oblohy
 destroy_Sclouds(); // zrusenie oblakov
}

// definicia objektov - suradnicova sustava ********************************
void mObjects::obj_axis(GLfloat color)
{
 glBegin(GL_LINES);             // ciary
  glColor4f(color,0.0f,0.0f,1.0f);
  for (t_a=0.0f;t_a>-100.0f;t_a-=10.0f) {
   glVertex3f(-50.0f,0.0f,t_a);  // X
   glVertex3f(100.0f,0.0f,t_a);
  }

  glColor4f(0.0f,color,0.0f,1.0f);
  for (t_a=0.0f;t_a>-100.0f;t_a-=10.0f) {
   glVertex3f(0.0f,-50.0f,t_a);  // Y
   glVertex3f(0.0f,100.0f,t_a);
  }

  glColor4f(0.0f,0.0f,color,1.0f);
  for (t_a=0.0f;t_a<100.0f;t_a+=10.0f) {
   glVertex3f(t_a,0.0f,-100.0f); // Z
   glVertex3f(t_a,0.0f,  50.0f);
  }
 glEnd();
}

// definicia objektov - XZ sachovnica **************************************
void mObjects::obj_XZplane(GLfloat color)
{
 glColor4f(color,color,color,1.0f);
 glBegin(GL_LINES);             // ciary
  for (t_a=-50.0f;t_a<=50.0f;t_a+=5.0f) {
   glVertex3f(t_a,0.0f, 50.0f);  // X
   glVertex3f(t_a,0.0f,-50.0f);
  }
  for (t_a=50.0f;t_a>=-50.0f;t_a-=5.0f) {
   glVertex3f(-50.0f,0.0f,t_a); // Z
   glVertex3f( 50.0f,0.0f,t_a);
  }
 glEnd();
}

// definicia objektov - XZ fill sachovnica *********************************
void mObjects::obj_XZplane1(GLfloat color)
{
 glColor4f(color,color,color,1.0f);
 glBegin(GL_QUADS); // plocha
  for (t_b=50.0f;t_b>-50.0f;t_b-=5.0f) {
   for (t_a=-50.0f;t_a<=50.0f;t_a+=5.0f) {
    glNormal3f(0.0f,1.0f,0.0f); glVertex3f(t_a     ,0.0f,t_b);
    glNormal3f(0.0f,1.0f,0.0f); glVertex3f(t_a+5.0f,0.0f,t_b);
    glNormal3f(0.0f,1.0f,0.0f); glVertex3f(t_a+5.0f,0.0f,t_b-5.0f);
    glNormal3f(0.0f,1.0f,0.0f); glVertex3f(t_a     ,0.0f,t_b-5.0f);
   }
  }
 glEnd();
}

// definicia objektov - XZ texturovana plocha ******************************
void mObjects::obj_XZplane2(GLfloat size)
{
 glBegin(GL_QUADS); // plocha
 for (t_b=0.0f;t_b>-size;t_b-=2.0f) {
  for (t_a=0.0f;t_a<size;t_a+=2.0f) {
   glNormal3f(0.0f,1.0f,0.0f); glTexCoord2f(0.0f,0.0f); glVertex3f(t_a,     0.0f,t_b);
   glNormal3f(0.0f,1.0f,0.0f); glTexCoord2f(1.0f,0.0f); glVertex3f(t_a+2.0f,0.0f,t_b);
   glNormal3f(0.0f,1.0f,0.0f); glTexCoord2f(1.0f,1.0f); glVertex3f(t_a+2.0f,0.0f,t_b-2.0f);
   glNormal3f(0.0f,1.0f,0.0f); glTexCoord2f(0.0f,1.0f); glVertex3f(t_a,     0.0f,t_b-2.0f);
  }
 }
 glEnd();
}

// definicia objektov - XYZ texturovana plocha *****************************
void mObjects::obj_XYZplane(GLfloat size)
{
 glBegin(GL_QUADS); // plocha
 for (t_b=0.0f;t_b>-size;t_b-=2.0f) {
  for (t_a=0.0f;t_a<size;t_a+=2.0f) {
   y1=0.0f; y2=0.0f; y3=0.0f; y4=0.0f;
   if (t_a==0.0f) { y1=1.0f; y4=1.0f; }
   if (t_a==(size-2.0f)) { y2=1.0f; y3=1.0f; }
   if (t_b==0.0f) { y1=1.0f; y2=1.0f; }
   if (t_b==(-size+2.0f)) { y3=1.0f; y4=1.0f; }
   glNormal3f(0.0f,1.0f,0.0f); glTexCoord2f(0.0f,0.0f); glVertex3f(t_a,     y1,t_b);
   glNormal3f(0.0f,1.0f,0.0f); glTexCoord2f(1.0f,0.0f); glVertex3f(t_a+2.0f,y2,t_b);
   glNormal3f(0.0f,1.0f,0.0f); glTexCoord2f(1.0f,1.0f); glVertex3f(t_a+2.0f,y3,t_b-2.0f);
   glNormal3f(0.0f,1.0f,0.0f); glTexCoord2f(0.0f,1.0f); glVertex3f(t_a,     y4,t_b-2.0f);
  }
 }
 glEnd();
}

// definicia objektov - kocka biela ****************************************
void mObjects::obj_cube0(GLfloat size)
{
 glColor4f(1.0f,1.0f,1.0f,0.6f); // farba, nastavena priesvitnost!
 glBegin(GL_QUADS);              // kocka
  glNormal3f(0.0f,0.0f,1.0f);
  glVertex3f(-size,-size,size);  // predna stena
  glVertex3f( size,-size,size);
  glVertex3f( size, size,size);
  glVertex3f(-size, size,size);

  glNormal3f(1.0f,0.0f,0.0f);
  glVertex3f(size,-size, size);  // prava stena
  glVertex3f(size,-size,-size);
  glVertex3f(size, size,-size);
  glVertex3f(size, size, size);

  glNormal3f(0.0f,0.0f,-1.0f);
  glVertex3f( size,-size,-size); // zadna stena
  glVertex3f(-size,-size,-size);
  glVertex3f(-size, size,-size);
  glVertex3f( size, size,-size);

  glNormal3f(-1.0f,0.0f,0.0f);
  glVertex3f(-size,-size,-size); // lava stena
  glVertex3f(-size,-size, size);
  glVertex3f(-size, size, size);
  glVertex3f(-size, size,-size);

  glNormal3f(0.0f,-1.0f,0.0f);
  glVertex3f(-size,-size,-size); // dolna stena
  glVertex3f( size,-size,-size);
  glVertex3f( size,-size, size);
  glVertex3f(-size,-size, size);

  glNormal3f(0.0f,1.0f,0.0f);
  glVertex3f(-size,size, size);  // horna stena
  glVertex3f( size,size, size);
  glVertex3f( size,size,-size);
  glVertex3f(-size,size,-size);
 glEnd();
}

// definicia objektov - kocka farebna **************************************
void mObjects::obj_cube1(GLfloat size)
{
 glBegin(GL_QUADS);               // kocka
  glNormal3f(0.0f,0.0f,1.0f);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(-size,-size,size);   // predna stena
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(size,-size,size);
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(size,size,size);
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(-size,size,size);

  glNormal3f(1.0f,0.0f,0.0f);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(size,-size,size);    // prava stena
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(size,-size,-size);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(size,size,-size);
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(size,size,size);

  glNormal3f(0.0f,0.0f,-1.0f);
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(size,-size,-size);   // zadna stena
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(-size,-size,-size);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(-size,size,-size);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(size,size,-size);

  glNormal3f(-1.0f,0.0f,0.0f);
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(-size,-size,-size);  // lava stena
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(-size,-size,size);
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(-size,size,size);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(-size,size,-size);

  glNormal3f(0.0f,-1.0f,0.0f);
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(-size,-size,-size);  // dolna stena
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(size,-size,-size);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(size,-size,size);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(-size,-size,size);

  glNormal3f(0.0f,1.0f,0.0f);
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(-size,size,size);    // horna stena
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(size,size,size);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(size,size,-size);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(-size,size,-size);
 glEnd();
}

// definicia objektov - kocka texturovana **********************************
void mObjects::obj_cube2(GLfloat size)
{
 glColor4f(1.0f,1.0f,1.0f,1.0f); // farba
 glBegin(GL_QUADS);              // kocka
  glNormal3f(0.0f,0.0f,1.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-size,-size,size);  // predna stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(size,-size,size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(size,size,size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(-size,size,size);

  glNormal3f(1.0f,0.0f,0.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(size,-size,size);   // prava stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(size,-size,-size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(size,size,-size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(size,size,size);

  glNormal3f(0.0f,0.0f,-1.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(size,-size,-size);  // zadna stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(-size,-size,-size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(-size,size,-size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(size,size,-size);

  glNormal3f(-1.0f,0.0f,0.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-size,-size,-size); // lava stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(-size,-size,size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(-size,size,size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(-size,size,-size);

  glNormal3f(0.0f,-1.0f,0.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-size,-size,-size); // dolna stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(size,-size,-size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(size,-size,size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(-size,-size,size);

  glNormal3f(0.0f,1.0f,0.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-size,size,size);   // horna stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(size,size,size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(size,size,-size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(-size,size,-size);
 glEnd();
}

// definicia objektov - kocka texturovana s normalou v kazdom vrchole ******
void mObjects::obj_cube2N(GLfloat size)
{
 glColor4f(1.0f,1.0f,1.0f,1.0f);  // farba
 glBegin(GL_QUADS);               // kocka
  glNormal3f(-0.577f,-0.577f,0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f(-size,-size,size);   // predna stena
  glNormal3f( 0.577f,-0.577f,0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f( size,-size,size);
  glNormal3f( 0.577f, 0.577f,0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f( size, size,size);
  glNormal3f(-0.577f, 0.577f,0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f(-size, size,size);

  glNormal3f(0.577f,-0.577f, 0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f(size,-size, size);   // prava stena
  glNormal3f(0.577f,-0.577f,-0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f(size,-size,-size);
  glNormal3f(0.577f, 0.577f,-0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f(size, size,-size);
  glNormal3f(0.577f, 0.577f, 0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f(size, size, size);

  glNormal3f( 0.577f,-0.577f,-0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f( size,-size,-size); // zadna stena
  glNormal3f(-0.577f,-0.577f,-0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f(-size,-size,-size);
  glNormal3f(-0.577f, 0.577f,-0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f(-size, size,-size);
  glNormal3f( 0.577f, 0.577f,-0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f( size, size,-size);

  glNormal3f(-0.577f,-0.577f,-0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f(-size,-size,-size); // lava stena
  glNormal3f(-0.577f,-0.577f, 0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f(-size,-size, size);
  glNormal3f(-0.577f, 0.577f, 0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f(-size, size, size);
  glNormal3f(-0.577f, 0.577f,-0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f(-size, size,-size);

  glNormal3f(-0.577f,-0.577f,-0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f(-size,-size,-size); // dolna stena
  glNormal3f( 0.577f,-0.577f,-0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f( size,-size,-size);
  glNormal3f( 0.577f,-0.577f, 0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f( size,-size, size);
  glNormal3f(-0.577f,-0.577f, 0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f(-size,-size, size);

  glNormal3f(-0.577f,0.577f, 0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f(-size,size, size);   // horna stena
  glNormal3f( 0.577f,0.577f, 0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f( size,size, size);
  glNormal3f( 0.577f,0.577f,-0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f( size,size,-size);
  glNormal3f(-0.577f,0.577f,-0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f(-size,size,-size);
 glEnd();
}

// definicia objektov - kvader texturovany ***********************************
void mObjects::obj_quad0(GLfloat Xsize,GLfloat Ysize)
{
 glColor4f(1.0f,1.0f,1.0f,1.0f);    // farba
 glBegin(GL_QUADS);                 // kvader
  glNormal3f(0.0f,0.0f,1.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-Xsize,-Ysize,Xsize);  // predna stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(Xsize,-Ysize,Xsize);
  glTexCoord2f(1.0f,Ysize/10.0f);
  glVertex3f(Xsize,Ysize,Xsize);
  glTexCoord2f(0.0f,Ysize/10.0f);
  glVertex3f(-Xsize,Ysize,Xsize);

  glNormal3f(1.0f,0.0f,0.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(Xsize,-Ysize,Xsize);   // prava stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(Xsize,-Ysize,-Xsize);
  glTexCoord2f(1.0f,Ysize/10.0f);
  glVertex3f(Xsize,Ysize,-Xsize);
  glTexCoord2f(0.0f,Ysize/10.0f);
  glVertex3f(Xsize,Ysize,Xsize);

  glNormal3f(0.0f,0.0f,-1.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(Xsize,-Ysize,-Xsize);  // zadna stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(-Xsize,-Ysize,-Xsize);
  glTexCoord2f(1.0f,Ysize/10.0f);
  glVertex3f(-Xsize,Ysize,-Xsize);
  glTexCoord2f(0.0f,Ysize/10.0f);
  glVertex3f(Xsize,Ysize,-Xsize);

  glNormal3f(-1.0f,0.0f,0.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-Xsize,-Ysize,-Xsize); // lava stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(-Xsize,-Ysize,Xsize);
  glTexCoord2f(1.0f,Ysize/10.0f);
  glVertex3f(-Xsize,Ysize,Xsize);
  glTexCoord2f(0.0f,Ysize/10.0f);
  glVertex3f(-Xsize,Ysize,-Xsize);

  glNormal3f(0.0f,-1.0f,0.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-Xsize,-Ysize,-Xsize); // dolna stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(Xsize,-Ysize,-Xsize);
  glTexCoord2f(1.0f,Ysize/10.0f);
  glVertex3f(Xsize,-Ysize,Xsize);
  glTexCoord2f(0.0f,Ysize/10.0f);
  glVertex3f(-Xsize,-Ysize,Xsize);

  glNormal3f(0.0f,1.0f,0.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-Xsize,Ysize,Xsize);   // horna stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(Xsize,Ysize,Xsize);
  glTexCoord2f(1.0f,Ysize/10.0f);
  glVertex3f(Xsize,Ysize,-Xsize);
  glTexCoord2f(0.0f,Ysize/10.0f);
  glVertex3f(-Xsize,Ysize,-Xsize);
 glEnd();
}

// inicializacia skyboxu ***************************************************
int mObjects::obj_skybox_init(char *mydir)
{
 char *names[6]={"skyfront","skyback","skybottom","skytop","skyright","skyleft"};
 char filename[128];
 int i;

 // alokovanie miesta pre data textur
 SDL_Surface *TextureImage[6];

 // generovanie jedinecnych identifikatorov 6-tich textur
 glGenTextures(6,skybox_tex_id);

 // vytvorenie textur
 for (i=0;i<6;i++) {
  strcpy(filename,"data/"); strcat(filename,mydir); strcat(filename,"/");
  strcat(filename,names[i]); strcat(filename,".bmp");

  TextureImage[i]=SDL_LoadBMP(filename);

  if (!TextureImage[i]) return(1);

  // vytvorenie textur
  glBindTexture(GL_TEXTURE_2D,skybox_tex_id[i]);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);

  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

  glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[i]->w,TextureImage[i]->h,
               0,GL_BGR,GL_UNSIGNED_BYTE,TextureImage[i]->pixels);
 }

 // uvolnenie pouzitej pamate
 for (i=0;i<6;i++) {
  if (TextureImage[i]) SDL_FreeSurface(TextureImage[i]);
 }

 skybox_DL_id=glGenLists(1);
 glNewList(skybox_DL_id,GL_COMPILE);

 glScalef(3.0f,1.5f,3.0f);

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[0]);
 // predna stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(1,1); glVertex3f(-1.0f,-1.0f,-1.0f);
  glTexCoord2f(0,1); glVertex3f( 1.0f,-1.0f,-1.0f);
  glTexCoord2f(0,0); glVertex3f( 1.0f, 1.0f,-1.0f);
  glTexCoord2f(1,0); glVertex3f(-1.0f, 1.0f,-1.0f);
 glEnd();

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[1]);
 // zadna stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(1,1); glVertex3f( 1.0f,-1.0f,1.0f);
  glTexCoord2f(0,1); glVertex3f(-1.0f,-1.0f,1.0f);
  glTexCoord2f(0,0); glVertex3f(-1.0f, 1.0f,1.0f);
  glTexCoord2f(1,0); glVertex3f( 1.0f, 1.0f,1.0f);
 glEnd();

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[2]);
 // spodna stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(0,0); glVertex3f(-1.0f,-1.0f, 1.0f);
  glTexCoord2f(1,0); glVertex3f( 1.0f,-1.0f, 1.0f);
  glTexCoord2f(1,1); glVertex3f( 1.0f,-1.0f,-1.0f);
  glTexCoord2f(0,1); glVertex3f(-1.0f,-1.0f,-1.0f);
 glEnd();

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[3]);
 // horna stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(0,0); glVertex3f(-1.0f,1.0f,-1.0f);
  glTexCoord2f(1,0); glVertex3f( 1.0f,1.0f,-1.0f);
  glTexCoord2f(1,1); glVertex3f( 1.0f,1.0f, 1.0f);
  glTexCoord2f(0,1); glVertex3f(-1.0f,1.0f, 1.0f);
 glEnd();

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[4]);
 // prava stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(1,1); glVertex3f( -1.0f,-1.0f, 1.0f);
  glTexCoord2f(0,1); glVertex3f( -1.0f,-1.0f,-1.0f);
  glTexCoord2f(0,0); glVertex3f( -1.0f, 1.0f,-1.0f);
  glTexCoord2f(1,0); glVertex3f( -1.0f, 1.0f, 1.0f);
 glEnd();

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[5]);
 // lava stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(1,1); glVertex3f(1.0f,-1.0f,-1.0f);
  glTexCoord2f(0,1); glVertex3f(1.0f,-1.0f, 1.0f);
  glTexCoord2f(0,0); glVertex3f(1.0f, 1.0f, 1.0f);
  glTexCoord2f(1,0); glVertex3f(1.0f, 1.0f,-1.0f);
 glEnd();

 glEndList();

 return(0);
}

// vykreslenie skyboxu *****************************************************
void mObjects::obj_skybox_draw(void)
{
 // ulozenie potrebnych atributov
 glPushAttrib(GL_TEXTURE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT);
 glEnable(GL_TEXTURE_2D);  // zapnutie texturovania
 glDisable(GL_DEPTH_TEST); // vypnutie testu hlbky
 glDisable(GL_LIGHTING);   // vypnutie osvetlenia

 glPushMatrix(); // ulozenie pohladovej matice

 glCallList(skybox_DL_id); // vykonanie prikazov ulozenych v displayliste

 glPopMatrix(); // vyber pohladovej matice

 glPopAttrib(); // obnova ulozenych atributov
}

// inicializacia oblohy ****************************************************
int mObjects::obj_sky_init(char *mydir)
{
 char *names[2]={"sky00","sky1"};
 char filename[128];
 int i;

 // alokovanie miesta pre data textur
 SDL_Surface *TextureImage[2];

 // generovanie jedinecnych identifikatorov 2 textur
 glGenTextures(2,sky_tex_id);

 // vytvorenie 1. textury
 i=0;
 strcpy(filename,"data/"); strcat(filename,mydir); strcat(filename,"/");
 strcat(filename,names[i]); strcat(filename,".bmp");

 TextureImage[i]=SDL_LoadBMP(filename);

 if (!TextureImage[i]) return(1);

 // vytvorenie textury
 glBindTexture(GL_TEXTURE_2D,sky_tex_id[i]);
 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);

 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

 glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[i]->w,TextureImage[i]->h,
              0,GL_BGR,GL_UNSIGNED_BYTE,TextureImage[i]->pixels);
 
 // vytvorenie 2. textury
 i=1;
 strcpy(filename,"data/"); strcat(filename,mydir); strcat(filename,"/");
 strcat(filename,names[i]); strcat(filename,".bmp");

 TextureImage[i]=SDL_LoadBMP(filename);

 if (!TextureImage[i]) return(1);

 // vytvorenie textury
 glBindTexture(GL_TEXTURE_2D,sky_tex_id[i]);
 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);

 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

 glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[i]->w,TextureImage[i]->h,
              0,GL_BGR,GL_UNSIGNED_BYTE,TextureImage[i]->pixels);

 // uvolnenie pouzitej pamate
 for (i=0;i<2;i++) {
  if (TextureImage[i]) SDL_FreeSurface(TextureImage[i]);
 }

 create_Ssphere(50.0f,20,15);        // vytvorenie objektu pologule
 create_Sclouds(300.0f,50.0f,0.95f); // vytvorenie objektu zakrivenej plochy
 
 sky_DL_id=glGenLists(1); // vytvorenie DisplayListu pre objekt oblohy
 glNewList(sky_DL_id,GL_COMPILE);

 draw_Ssphere(20,15); // graficke udaje o pologule su ulozene v DisplayListe

 glEndList();

 sky_time=0.0f; // pociatocny reset casu potrebneho pre pohyb oblakov
 
 return(0);
}

// vykreslenie oblohy ******************************************************
void mObjects::obj_sky_draw(GLfloat tadd)
{
 // ulozenie potrebnych atributov
 glPushAttrib(GL_TEXTURE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT);
 glEnable(GL_TEXTURE_2D);  // zapnutie texturovania
 glDisable(GL_DEPTH_TEST); // vypnutie testu hlbky
 glDisable(GL_LIGHTING);   // vypnutie osvetlenia

 glPushMatrix(); // ulozenie pohladovej matice

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,sky_tex_id[0]);
 glCallList(sky_DL_id); // obloha nahradena pologulov sa kresli vyvolanim
	                    // prikazov ulozenych v DisplayListe

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,sky_tex_id[1]);
 // modifikacia matice textury - pohyb oblakov
 glMatrixMode(GL_TEXTURE);
 glLoadIdentity();
 sky_time+=tadd/40.0f;
 glTranslatef(sky_time,0.0f,0.0f);
 
 // textura oblakov je polopriesvitna
 glBlendFunc(GL_SRC_ALPHA,GL_ONE);
 glAlphaFunc(GL_GREATER,0.1f);
 glEnable(GL_BLEND);

 draw_Sclouds(); // vykreslenie oblakov

 glDisable(GL_BLEND);

 glLoadIdentity(); // pre texturovu maticu

 glMatrixMode(GL_MODELVIEW); // obnova povodneho maticoveho modu - modelview
	
 glPopMatrix(); // vyber pohladovej matice

 glPopAttrib(); // obnova ulozenych atributov
}

// inicializacia kvadratickych objektov ************************************
int mObjects::obj_quadratic_init(void)
{
 obj_quad=gluNewQuadric();               // ukazatel na novy quadratic objekt
 gluQuadricNormals(obj_quad,GLU_SMOOTH); // vyhladene normalove vektory
 gluQuadricTexture(obj_quad,GL_TRUE);    // koordinaty textury

 return(0);
}

// vykreslenie kvadratickeho objektu ***************************************
void mObjects::obj_quadratic(GLuint type,GLfloat param,GLfloat color)
{
 // farba
 glColor4f(color,color,color,1.0f);

 // vyber objektu - gula, valec, ihlan, disk, vysec z disku, uzavrety valec
 switch (type) {
  case 0: gluSphere(obj_quad,param,32,32); break;
  case 1: gluCylinder(obj_quad,param/4.0f,param/4.0f,param,32,32); break;
  case 2: gluCylinder(obj_quad,param/4.0f,0.0f,param,32,32); break;
  case 3: gluDisk(obj_quad,param/4.0f,param,32,32); break;
  case 4: gluPartialDisk(obj_quad,param/4.0f,param,32,32,0.0f,180.0f); break;
  case 5: gluCylinder(obj_quad,param/4.0f,param/4.0f,2.0f*param,32,32); 
	      glPushMatrix();
           glTranslatef(0.0f,0.0f,2.0f*param);
           gluDisk(obj_quad,0.0f,param/4.0f,32,32);
          glPopMatrix();
          glPushMatrix();
           glRotatef(180.0f,0.0f,1.0f,0.0f);
           gluDisk(obj_quad,0.0f,param/4.0f,32,32);
          glPopMatrix();
          break;
  default: break;
 }
}

// inicializacia sosovkoveho efektu ****************************************
int mObjects::obj_lensflare_init(char *mydir)
{
 char *names[6]={"flare1","flare2","flare3","flare4","flare5","flare6"};
 char filename[128];
 int i;

 // alokovanie miesta pre data textur
 SDL_Surface *TextureImage[6];

 // generovanie jedinecnych identifikatorov 6-tich textur
 glGenTextures(6,lensflare_tex_id);

 // vytvorenie textur
 for (i=0;i<6;i++) {
  strcpy(filename,"data/"); strcat(filename,mydir); strcat(filename,"/");
  strcat(filename,names[i]); strcat(filename,".bmp");

  TextureImage[i]=SDL_LoadBMP(filename);

  if (!TextureImage[i]) return(1);

  // vytvorenie textur
  glBindTexture(GL_TEXTURE_2D,lensflare_tex_id[i]);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);

  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

  glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[i]->w,TextureImage[i]->h,
               0,GL_BGR,GL_UNSIGNED_BYTE,TextureImage[i]->pixels);
 }

 // uvolnenie pouzitej pamate
 for (i=0;i<6;i++) {
  if (TextureImage[i]) SDL_FreeSurface(TextureImage[i]);
 }

 return(0);
}

// test ci sa pred svetlom nachadza iny objekt *****************************
bool mObjects::isOccluded(m3Dvector point)
{
 glGetIntegerv(GL_VIEWPORT,VP);               // ziskanie viewportu
 glGetDoublev(GL_MODELVIEW_MATRIX,MVmatrix);  // ziskanie modelview matice
 glGetDoublev(GL_PROJECTION_MATRIX,PRmatrix); // ziskanie projekcnej matice
 // prepocet 3D bodu do 2D, vrati poziciu v 2D viewporte
 gluProject(point.x,point.y,point.z,MVmatrix,PRmatrix,VP,&winx,&winy,&winz);
 flareZ=winz;
 // ziskanie hlbky zo zasobnika hlbky
 glReadPixels((GLint) winx,(GLint) winy,1,1,GL_DEPTH_COMPONENT,GL_FLOAT,&bufferZ);

 // ak je "hlbka" svetla viac ako hlbka ulozena v zasobniku hlbky, pred svetlom
 // sa nachadza nejaky iny objekt
 if (bufferZ<flareZ) return true;
 return false;
}

// vykreslenie castice sosovkoveho efektu **********************************
void mObjects::lflare(GLuint tex_id,
                      GLfloat r,GLfloat g,GLfloat b,GLfloat a,
                      m3Dvector point,
                      GLfloat scale)
{
 // vrchol A
 p[0].x=(point.x+(-RightV.x-UpV.x)*scale);
 p[0].y=(point.y+(-RightV.y-UpV.y)*scale);
 p[0].z=(point.z+(-RightV.z-UpV.z)*scale);
 // vrchol B
 p[1].x=(point.x+(+RightV.x-UpV.x)*scale);
 p[1].y=(point.y+(+RightV.y-UpV.y)*scale);
 p[1].z=(point.z+(+RightV.z-UpV.z)*scale);
 // vrchol C
 p[2].x=(point.x+(+RightV.x+UpV.x)*scale);
 p[2].y=(point.y+(+RightV.y+UpV.y)*scale);
 p[2].z=(point.z+(+RightV.z+UpV.z)*scale);
 // vrchol D
 p[3].x=(point.x+(-RightV.x+UpV.x)*scale);
 p[3].y=(point.y+(-RightV.y+UpV.y)*scale);
 p[3].z=(point.z+(-RightV.z+UpV.z)*scale);

 glPushMatrix();
 glBindTexture(GL_TEXTURE_2D,tex_id); // zvolenie patricnej textury
 glColor4f(r,g,b,a);                  // uprava farby
 glBegin(GL_TRIANGLE_FAN); // vejar trojuholnikov=stvoruholnik
  glTexCoord2f(0.0f,0.0f); glVertex3f(p[0].x,p[0].y,p[0].z);
  glTexCoord2f(1.0f,0.0f); glVertex3f(p[1].x,p[1].y,p[1].z);
  glTexCoord2f(1.0f,1.0f); glVertex3f(p[2].x,p[2].y,p[2].z);
  glTexCoord2f(0.0f,1.0f); glVertex3f(p[3].x,p[3].y,p[3].z);
 glEnd();
 glPopMatrix();
}

// sosovkovy efekt pohladu do svetla (slnka) *******************************
void mObjects::obj_lensflare(GLfloat c1,GLfloat c2,GLfloat c3,
                             GLfloat t1,GLfloat t2,GLfloat t3,
                             GLfloat u1,GLfloat u2,GLfloat u3,
                             GLfloat r1,GLfloat r2,GLfloat r3,
                             GLfloat l1,GLfloat l2,GLfloat l3)
{
 CameraP.x=-c1; CameraP.y=-c2; CameraP.z=-c3; // prevzatie polohy kamery
 TargetP.x=-t1; TargetP.y=-t2; TargetP.z=-t3; // prevzatie smerovaho vektora kamery
 UpV.x=u1; UpV.y=u2; UpV.z=u3;                // prevzatie Up vektora kamery
 RightV.x=r1; RightV.y=r2; RightV.z=r3;       // prevzatie Right vektora kamery
 LightP.x=l1; LightP.y=l2; LightP.z=l3;       // prevzatie polohy svetla

 if (!isOccluded(LightP)) {
  // ak je svetelny zdroj viditelny, dojde k vykresleniu sosovkoveho efektu

  CameraLightVector=LightP-CameraP; // vektor kamera->svetlo
  l=CameraLightVector.Magnitude();  // velkost vektora

  // pozicia priesecnika smeroveho vektora kamery a gulovej plochy
  // s polomerom rovnakym ako vzdialenost kamery od svetla
  IntersectP=CameraP+TargetP*l;
  LightIntersectVector=IntersectP-LightP; // vektor svetlo->priesecnik
  l=LightIntersectVector.Magnitude();     // velkost vektora
  LightIntersectVector.Normalize();       // normalizacia vektora

  // ulozenie potrebnych atributov
  glPushAttrib(GL_TEXTURE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT);
  glEnable(GL_TEXTURE_2D);  // zapnutie texturovania
  glDisable(GL_DEPTH_TEST); // vypnutie testu hlbky
  glDisable(GL_LIGHTING);   // vypnutie osvetlenia

  glEnable(GL_BLEND);               // zapnutie priesvitnosti
  glBlendFunc(GL_SRC_ALPHA,GL_ONE); // kombinacna funkcia pre priesvitnost

  // vykresli sa 1. textura na pozicii svetla
  lflare(lensflare_tex_id[0],0.58f,0.25f,0.23f,0.4f,LightP,600.0f);
  // postupne sa vykreslia textury sosovkoveho efektu v
  // patricnej vzdialenosti od svetelneho zdroja
  middleP=LightP+LightIntersectVector*(l*0.1f);
  lflare(lensflare_tex_id[1],1.0f,1.0f,1.0f,0.1f,middleP,1400.0f);
  middleP=LightP+LightIntersectVector*(l*0.5f);
  lflare(lensflare_tex_id[2],0.10f,0.09f,0.11f,0.4f,middleP,400.0f);
  middleP=LightP+LightIntersectVector*(l*0.6f);
  lflare(lensflare_tex_id[3],0.10f,0.12f,0.16f,0.2f,middleP,200.0f);
  middleP=LightP+LightIntersectVector*(l*0.9f);
  lflare(lensflare_tex_id[3],0.18f,0.09f,0.02f,0.5f,middleP,200.0f);
  middleP=LightP+LightIntersectVector*(l*1.0f);
  lflare(lensflare_tex_id[4],0.30f,0.55f,0.42f,0.2f,middleP,100.0f);
  middleP=LightP+LightIntersectVector*(l*1.3f);
  lflare(lensflare_tex_id[4],0.30f,0.55f,0.42f,0.3f,middleP,200.0f);
  middleP=LightP+LightIntersectVector*(l*1.7f);
  lflare(lensflare_tex_id[2],0.18f,0.09f,0.02f,0.4f,middleP,700.0f);
  middleP=LightP+LightIntersectVector*(l*2.2f);
  lflare(lensflare_tex_id[5],0.04f,0.09f,0.00f,0.5f,middleP,1500.0f);

  glDisable(GL_BLEND); // vyputie priesvitnosti

  glPopAttrib(); // vyber ulozenych atributov
 }
}

// vytvorenie pologule *****************************************************
int mObjects::create_Ssphere(GLfloat r,GLint t1,GLint t2)
{
 GLint i1,i2;
 GLuint j,k;
 GLfloat a,b,c,d;
 GLfloat u,v;
 GLfloat r1;

 destroy_Ssphere(); // zrusenie predosleho objektu (ak existuje)

 // alokacia pamate pre vrcholy a texturovacie suradnice
 Ssphere.v_array=(GLfloat *) malloc((3*3*(4*(360/t1)*(360/t2)))*sizeof(GLfloat));
 Ssphere.t_array=(GLfloat *) malloc((2*3*(4*(360/t1)*(360/t2)))*sizeof(GLfloat));
 if ((Ssphere.v_array==NULL)||(Ssphere.t_array==NULL)) {
  return(1);
 }

 j=0; k=0;       // posun indexov v zozname vrholov a texturovacich suradnic
 u=0.0f; v=0.0f; // pociatocne nastavenie texturovacich suradnic

 r1=r/3.0f; // pologula bude splostena v smere osi y
  
 i2=0;
 while (i2<(90)) { // 0-90 st. vo vertikalnom smere
  i1=180;
  while (i1>-180) { // -180-180 st. v horizontalnom smere
   a=(PI/180.0f)*(GLfloat) i1;
   // pre korektne uzavretie pologule sa posledne vrcholy spocitaju vzdy
   // na -180, resp. 90 st. hranici
   if ((i1-t1)>-180) b=(PI/180.0f)*(GLfloat) (i1-t1);
   else b=(PI/180.0f)*(GLfloat) (-180);

   c=(PI/180.0f)*(GLfloat) i2;
   if ((i2+t2)<90) d=(PI/180.0f)*(GLfloat) (i2+t2);
   else d=(PI/180.0f)*(GLfloat) (90);

   // vypocet vrcholov dvojice trojuholnikov   
   *(Ssphere.v_array+j+0)=r*(GLfloat) (sin(a)*cos(c));
   *(Ssphere.v_array+j+1)=r1*(GLfloat) sin(c);
   *(Ssphere.v_array+j+2)=r*(GLfloat) (cos(a)*cos(c));
   *(Ssphere.v_array+j+3)=r*(GLfloat) (sin(b)*cos(d));
   *(Ssphere.v_array+j+4)=r1*(GLfloat) sin(d);
   *(Ssphere.v_array+j+5)=r*(GLfloat) (cos(b)*cos(d));
   *(Ssphere.v_array+j+6)=r*(GLfloat) (sin(a)*cos(d));
   *(Ssphere.v_array+j+7)=r1*(GLfloat) sin(d);
   *(Ssphere.v_array+j+8)=r*(GLfloat) (cos(a)*cos(d));

   *(Ssphere.v_array+j+9)=r*(GLfloat) (sin(a)*cos(c));
   *(Ssphere.v_array+j+10)=r1*(GLfloat) sin(c);
   *(Ssphere.v_array+j+11)=r*(GLfloat) (cos(a)*cos(c));
   *(Ssphere.v_array+j+12)=r*(GLfloat) (sin(b)*cos(c));
   *(Ssphere.v_array+j+13)=r1*(GLfloat) sin(c);
   *(Ssphere.v_array+j+14)=r*(GLfloat) (cos(b)*cos(c));
   *(Ssphere.v_array+j+15)=r*(GLfloat) (sin(b)*cos(d));
   *(Ssphere.v_array+j+16)=r1*(GLfloat) sin(d);
   *(Ssphere.v_array+j+17)=r*(GLfloat) (cos(b)*cos(d));

   // vypocet texturovacich suradnic pre dvojicu trojuholnikov
   *(Ssphere.t_array+k+0)=u;
   *(Ssphere.t_array+k+1)=v;
   *(Ssphere.t_array+k+2)=u+1.0f/(GLfloat) (360/t1);
   *(Ssphere.t_array+k+3)=v+1.0f/(GLfloat) (90/t2);
   *(Ssphere.t_array+k+4)=u;
   *(Ssphere.t_array+k+5)=v+1.0f/(GLfloat) (90/t2);
   
   *(Ssphere.t_array+k+6)=u;
   *(Ssphere.t_array+k+7)=v;
   *(Ssphere.t_array+k+8)=u+1.0f/(GLfloat) (360/t1);
   *(Ssphere.t_array+k+9)=v;
   *(Ssphere.t_array+k+10)=u+1.0f/(GLfloat) (360/t1);
   *(Ssphere.t_array+k+11)=v+1.0f/(GLfloat) (90/t2);
   
   j+=18; k+=12;
   
   i1-=t1;
   u+=1.0f/(GLfloat) (360/t1); // vypocet novej text. suradnice pre u
  }
  i2+=t2;
  u=0.0f; v+=1.0f/(GLfloat) (90/t2); // vypocet novej text. suradnice pre v
 }

 return(0);
}

// vykreslenie pologule ****************************************************
void mObjects::draw_Ssphere(GLint t1,GLint t2)
{
 GLint i1,i2;
 GLuint j,k;

 j=0; k=0;

 // kresli sa vzdy dvojica trojuholnikov, suradnice vrcholov su ulozene
 // v zozname Ssphere.t_array a texturovacie suradnice v zozname
 // Ssphere.v_array
 glBegin(GL_TRIANGLES);

 i2=0;
 while (i2<(90)) {
  i1=180;
  while (i1>-180) {
   // 1. trojuholik
   glTexCoord2f(*(Ssphere.t_array+k+0),*(Ssphere.t_array+k+1));
   glVertex3f(*(Ssphere.v_array+j+0),*(Ssphere.v_array+j+1),*(Ssphere.v_array+j+2));
   glTexCoord2f(*(Ssphere.t_array+k+2),*(Ssphere.t_array+k+3));
   glVertex3f(*(Ssphere.v_array+j+3),*(Ssphere.v_array+j+4),*(Ssphere.v_array+j+5));
   glTexCoord2f(*(Ssphere.t_array+k+4),*(Ssphere.t_array+k+5));
   glVertex3f(*(Ssphere.v_array+j+6),*(Ssphere.v_array+j+7),*(Ssphere.v_array+j+8));
   // 2. trojuholik
   glTexCoord2f(*(Ssphere.t_array+k+6),*(Ssphere.t_array+k+7));
   glVertex3f(*(Ssphere.v_array+j+9),*(Ssphere.v_array+j+10),*(Ssphere.v_array+j+11));
   glTexCoord2f(*(Ssphere.t_array+k+8),*(Ssphere.t_array+k+9));
   glVertex3f(*(Ssphere.v_array+j+12),*(Ssphere.v_array+j+13),*(Ssphere.v_array+j+14));
   glTexCoord2f(*(Ssphere.t_array+k+10),*(Ssphere.t_array+k+11));
   glVertex3f(*(Ssphere.v_array+j+15),*(Ssphere.v_array+j+16),*(Ssphere.v_array+j+17));

   j+=18; k+=12;
   
   i1-=t1;
  }
  i2+=t2;
 }
 
 glEnd();
}

// uvolnenie pamate ********************************************************
void mObjects::destroy_Ssphere(void)
{
 if (Ssphere.v_array!=NULL) free(Ssphere.v_array); // zrusenie vrcholov
 if (Ssphere.t_array!=NULL) free(Ssphere.t_array); // zrusenie texturovacich suradnic
 Ssphere.v_array=NULL;
 Ssphere.t_array=NULL;
}

// vytvorenie zakrivenej plochy ********************************************
int mObjects::create_Sclouds(GLfloat r1,GLfloat r2,GLfloat alphaP)
{
 GLuint divs=20;  // pocet poli objektu zakrivenej plochy
 GLfloat ht=4.0f; // pocet opakovani textury, ktorou je pokryta plocha v horiz. smere
 GLfloat vt=4.0f; // pocet opakovani textury, ktorou je pokryta plocha vo vert. smere

 // vypocet velkosti plochy
 GLfloat PlaneSize=(GLfloat) sqrt(((2.0f*r1)*(2.0f*r1))*0.5f);
 // vypocet velkosti 1 pola plochy - prirastku suradnic vrcholov
 GLfloat delta=PlaneSize/(GLfloat) divs;
 // vypocet prirastku texturovacich suradnic
 GLfloat Tdelta=1.0f/(GLfloat) divs;
 // koeficient pre vypocet priesvitnosti - v zavislosti na vzdialenosti vrcholu od stredu plochy
 GLfloat alphaP_sq=(PlaneSize*alphaP*0.5f)*(PlaneSize*alphaP*0.5f);
 // koeficient pre vypocet vysky vrcholu - v zavislosti na vzdialenosti vrcholu od stredu plochy
 GLfloat r1_sq=r1*r1;

 // docasna premenna
 _Sclouds v;
	
 destroy_Sclouds(); // uvolnenie pamate (ak uz bol niekedy objekt vytvoreny)
 
 NumPlaneVertices=(divs+1)*(divs+1); // plocha zlozena zo stvoruholnikov
 NumIndices=divs*divs*2*3;           // 2 trojuholiky, pre kazdy 3 vrcholy

 // alokovanie miesta pre vrcholy plochy
 PlaneVertices=(_Sclouds *) malloc(NumPlaneVertices*sizeof(_Sclouds));
 // alokovanie miesta pre odkazy na jednotlive vrcholy
 Indices=(GLuint *) malloc(NumIndices*sizeof(GLuint));
 if ((PlaneVertices==NULL)||(Indices==NULL)) {
  return(1);
 }

 // vypocet polohy a vysky vsetkych bodov, text. suradnic a priesvitnosti
 for (t_d=0;t_d<=divs;t_d++) {
  for (t_c=0;t_c<=divs;t_c++) {
   // vypocet suradnic x a z
   v.x=(-0.5f*PlaneSize)+((GLfloat) t_c*delta);
   v.z=(-0.5f*PlaneSize)+((GLfloat) t_d*delta);
   // vypocet suradnice y
   v.y=(v.x*v.x+v.z*v.z)/r1_sq;
   v.y=(1.0f-v.y)*r2;
   // vypocet priesvitnosti textury v danom vrchole
   v.a=(v.x*v.x+v.z*v.z)/alphaP_sq;
   v.a=1.0f-v.a*v.a*v.a;
   if (v.a<0.0f) v.a=0.0f;
   // vypocet texturovacich suradnic
   v.u=ht*((GLfloat) t_c*Tdelta);
   v.v=vt*((GLfloat) t_d*Tdelta);
   // ulozenie vypocitanych hodnot do zoznamu
   PlaneVertices[t_d*(divs+1)+t_c]=v;
  }
 }

 GLuint a=0,b=0;
 // vytvorenie zoznamu indexov na vrcholy tvoriacich vzdy
 // 2 susediace trojuholiky = 1 stvoruholnik
 for (t_d=0;t_d<divs;t_d++)	{
  for (t_c=0;t_c<divs;t_c++) {
   b=(t_d*(divs+1)+t_c);
   // 1. trojuholik
   Indices[a++]=b; Indices[a++]=b+1; Indices[a++]=b+divs+1;
   // 2. trojuholik
   Indices[a++]=b+1; Indices[a++]=b+divs+2; Indices[a++]=b+divs+1;
  }
 }

 return(0);
}

// vykreslenie zakrivenej plochy *******************************************
void mObjects::draw_Sclouds(void)
{
 // zakrivena plocha je zlozena zo stvoruholnikov, kazdy stvoruholnik
 // je zlozeny z dvoch trojuholnikov
 glBegin(GL_TRIANGLES);

 for (t_c=0;t_c<NumIndices;t_c++)	{
  // farba - je dolezita pre urcenie priesvitnosti - alfa hodnota
  glColor4f(1.0f,1.0f,1.0f,PlaneVertices[Indices[t_c]].a);
  // texturovacie suradnice
  glTexCoord2f(PlaneVertices[Indices[t_c]].u,
	           PlaneVertices[Indices[t_c]].v);
  // vrcholy trojuholnikov
  glVertex3f(PlaneVertices[Indices[t_c]].x,
	         PlaneVertices[Indices[t_c]].y,
             PlaneVertices[Indices[t_c]].z);
 }

 glEnd();
}

// uvolnenie pamate ********************************************************
void mObjects::destroy_Sclouds(void)
{
 if (PlaneVertices!=NULL) { // zrusenie objektu oblohy
  free(PlaneVertices); PlaneVertices=NULL;
 }
 
 if (Indices!=NULL) {       // zrusenie objektu oblakov
  free(Indices); Indices=NULL;
 }
}
